/// Enum class mapped to iOS AVAudioSession categories.
///
/// [AudioSessionCategory.ambient] refers to AVAudioSession.Category.ambient.
/// [AudioSessionCategory.multiRoute] refers to AVAudioSession.Category.multiRoute.
/// [AudioSessionCategory.playAndRecord] refers to AVAudioSession.Category.playAndRecord.
/// [AudioSessionCategory.playback] refers to AVAudioSession.Category.playback.
/// [AudioSessionCategory.record] refers to AVAudioSession.Category.record.
/// [AudioSessionCategory.soleAmbient] refers to AVAudioSession.Category.soleAmbient.
enum AudioSessionCategory {
  ambient,
  multiRoute,
  playAndRecord,
  playback,
  record,
  soleAmbient
}
